function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Handle virtual list of the TreeNodes.
 */
import * as React from 'react';
import VirtualList from 'rc-virtual-list';
import KeyCode from "rc-util/es/KeyCode";
import MotionTreeNode from './MotionTreeNode';
import { TreeContext } from './contextTypes';
import { findExpandedKeys, getExpandRange } from './utils/diffUtil';
import { getTreeNodeProps, getKey, convertNodePropsToEventData } from './utils/treeUtil';
var HIDDEN_STYLE = {
  width: 0,
  height: 0,
  display: 'flex',
  overflow: 'hidden',
  opacity: 0
};
export var MOTION_KEY = "RC_TREE_MOTION_".concat(Math.random());
var MotionNode = {
  key: MOTION_KEY
};
export var MotionEntity = {
  key: MOTION_KEY,
  level: 0,
  index: 0,
  pos: '0',
  node: MotionNode
};
var MotionFlattenData = {
  parent: null,
  children: [],
  pos: MotionEntity.pos,
  data: MotionNode,

  /** Hold empty list here since we do not use it */
  isStart: [],
  isEnd: []
};
/**
 * We only need get visible content items to play the animation.
 */

export function getMinimumRangeTransitionRange(list, height, itemHeight) {
  if (!height) {
    return list;
  }

  return list.slice(0, Math.ceil(height / itemHeight) + 1);
}

function itemKey(item) {
  var key = item.data.key,
      pos = item.pos;
  return String(getKey(key, pos));
}

function getAccessibilityPath(item) {
  var path = String(item.data.key);
  var current = item;

  while (current.parent) {
    current = current.parent;
    path = "".concat(current.data.key, " > ").concat(path);
  }

  return path;
}

var NodeList = function NodeList(_ref) {
  var prefixCls = _ref.prefixCls,
      data = _ref.data,
      selectable = _ref.selectable,
      checkable = _ref.checkable,
      expandedKeys = _ref.expandedKeys,
      selectedKeys = _ref.selectedKeys,
      checkedKeys = _ref.checkedKeys,
      loadedKeys = _ref.loadedKeys,
      loadingKeys = _ref.loadingKeys,
      halfCheckedKeys = _ref.halfCheckedKeys,
      keyEntities = _ref.keyEntities,
      dragging = _ref.dragging,
      dragOverNodeKey = _ref.dragOverNodeKey,
      dropPosition = _ref.dropPosition,
      motion = _ref.motion,
      height = _ref.height,
      itemHeight = _ref.itemHeight,
      focusable = _ref.focusable,
      focused = _ref.focused,
      tabIndex = _ref.tabIndex,
      onKeyDown = _ref.onKeyDown,
      onFocus = _ref.onFocus,
      onBlur = _ref.onBlur,
      onActiveChange = _ref.onActiveChange,
      domProps = _objectWithoutProperties(_ref, ["prefixCls", "data", "selectable", "checkable", "expandedKeys", "selectedKeys", "checkedKeys", "loadedKeys", "loadingKeys", "halfCheckedKeys", "keyEntities", "dragging", "dragOverNodeKey", "dropPosition", "motion", "height", "itemHeight", "focusable", "focused", "tabIndex", "onKeyDown", "onFocus", "onBlur", "onActiveChange"]);

  // ============================== Motion ==============================
  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      disableVirtual = _React$useState2[0],
      setDisableVirtual = _React$useState2[1];

  var _React$useState3 = React.useState(expandedKeys),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      prevExpandedKeys = _React$useState4[0],
      setPrevExpandedKeys = _React$useState4[1];

  var _React$useState5 = React.useState(data),
      _React$useState6 = _slicedToArray(_React$useState5, 2),
      prevData = _React$useState6[0],
      setPrevData = _React$useState6[1];

  var _React$useState7 = React.useState(data),
      _React$useState8 = _slicedToArray(_React$useState7, 2),
      transitionData = _React$useState8[0],
      setTransitionData = _React$useState8[1];

  var _React$useState9 = React.useState([]),
      _React$useState10 = _slicedToArray(_React$useState9, 2),
      transitionRange = _React$useState10[0],
      setTransitionRange = _React$useState10[1];

  var _React$useState11 = React.useState(null),
      _React$useState12 = _slicedToArray(_React$useState11, 2),
      motionType = _React$useState12[0],
      setMotionType = _React$useState12[1];

  function onMotionEnd() {
    setPrevData(data);
    setTransitionData(data);
    setTransitionRange([]);
    setMotionType(null);
    setDisableVirtual(false);
  } // Do animation if expanded keys changed


  React.useEffect(function () {
    setPrevExpandedKeys(expandedKeys);
    var diffExpanded = findExpandedKeys(prevExpandedKeys, expandedKeys);

    if (diffExpanded.key !== null) {
      if (diffExpanded.add) {
        var keyIndex = prevData.findIndex(function (_ref2) {
          var key = _ref2.data.key;
          return key === diffExpanded.key;
        });
        if (motion) setDisableVirtual(true);
        var rangeNodes = getMinimumRangeTransitionRange(getExpandRange(prevData, data, diffExpanded.key), height, itemHeight);
        var newTransitionData = prevData.slice();
        newTransitionData.splice(keyIndex + 1, 0, MotionFlattenData);
        setTransitionData(newTransitionData);
        setTransitionRange(rangeNodes);
        setMotionType('show');
      } else {
        var _keyIndex = data.findIndex(function (_ref3) {
          var key = _ref3.data.key;
          return key === diffExpanded.key;
        });

        if (motion) setDisableVirtual(true);

        var _rangeNodes = getMinimumRangeTransitionRange(getExpandRange(data, prevData, diffExpanded.key), height, itemHeight);

        var _newTransitionData = data.slice();

        _newTransitionData.splice(_keyIndex + 1, 0, MotionFlattenData);

        setTransitionData(_newTransitionData);
        setTransitionRange(_rangeNodes);
        setMotionType('hide');
      }
    } else if (prevData !== data) {
      // If whole data changed, we just refresh the list
      setPrevData(data);
      setTransitionData(data);
    }
  }, [expandedKeys, data]); // We should clean up motion if is changed by dragging

  React.useEffect(function () {
    if (!dragging) {
      onMotionEnd();
    }
  }, [dragging]);
  var mergedData = motion ? transitionData : data;
  var treeNodeRequiredProps = {
    expandedKeys: expandedKeys,
    selectedKeys: selectedKeys,
    loadedKeys: loadedKeys,
    loadingKeys: loadingKeys,
    checkedKeys: checkedKeys,
    halfCheckedKeys: halfCheckedKeys,
    dragOverNodeKey: dragOverNodeKey,
    dropPosition: dropPosition,
    keyEntities: keyEntities
  }; // =========================== Accessibility ==========================

  var _React$useState13 = React.useState(null),
      _React$useState14 = _slicedToArray(_React$useState13, 2),
      activeKey = _React$useState14[0],
      setInnerActiveKey = _React$useState14[1];

  function setActiveKey(key) {
    setInnerActiveKey(key);
    onActiveChange(key);
  }

  var activeItem = data.find(function (_ref4) {
    var key = _ref4.data.key;
    return key === activeKey;
  });

  var changeActive = function changeActive(offset) {
    var index = data.findIndex(function (_ref5) {
      var key = _ref5.data.key;
      return key === activeKey;
    }); // Align with index

    if (index === -1 && offset < 0) {
      index = data.length;
    }

    index = (index + offset + data.length) % data.length;
    var item = data[index];

    if (item) {
      setActiveKey(item.data.key);
    } else {
      setActiveKey(null);
    }
  }; // Clean up `activeKey` if blur


  React.useEffect(function () {
    if (!focused) {
      setActiveKey(null);
    }
  }, [focused]); // ============================= Keyboard =============================

  var _React$useContext = React.useContext(TreeContext),
      onNodeExpand = _React$useContext.onNodeExpand,
      onNodeCheck = _React$useContext.onNodeCheck,
      onNodeSelect = _React$useContext.onNodeSelect;

  var onInternalKeyDown = function onInternalKeyDown(event) {
    // >>>>>>>>>> Direction
    switch (event.which) {
      case KeyCode.UP:
        {
          changeActive(-1);
          event.preventDefault();
          break;
        }

      case KeyCode.DOWN:
        {
          changeActive(1);
          event.preventDefault();
          break;
        }
    }

    if (activeItem && activeItem.data) {
      // >>>>>>>>>> Expand & Selection
      var expandable = activeItem.data.isLeaf === false || !!(activeItem.data.children || []).length;
      var eventNode = convertNodePropsToEventData(_objectSpread({}, getTreeNodeProps(activeKey, treeNodeRequiredProps), {
        data: activeItem.data,
        active: true
      }));

      switch (event.which) {
        // >>> Expand
        case KeyCode.LEFT:
          {
            // Collapse if possible
            if (expandable && expandedKeys.includes(activeKey)) {
              onNodeExpand({}, eventNode);
            } else if (activeItem.parent) {
              setActiveKey(activeItem.parent.data.key);
            }

            event.preventDefault();
            break;
          }

        case KeyCode.RIGHT:
          {
            // Expand if possible
            if (expandable && !expandedKeys.includes(activeKey)) {
              onNodeExpand({}, eventNode);
            } else if (activeItem.children && activeItem.children.length) {
              setActiveKey(activeItem.children[0].data.key);
            }

            event.preventDefault();
            break;
          }
        // Selection

        case KeyCode.ENTER:
        case KeyCode.SPACE:
          {
            if (checkable && !eventNode.disabled && eventNode.checkable !== false && !eventNode.disableCheckbox) {
              onNodeCheck({}, eventNode, !checkedKeys.includes(activeKey));
            } else if (!checkable && selectable && !eventNode.disabled && eventNode.selectable !== false) {
              onNodeSelect({}, eventNode);
            }

            break;
          }
      }
    }

    if (onKeyDown) {
      onKeyDown(event);
    }
  };

  return React.createElement(React.Fragment, null, focused && activeItem && React.createElement("span", {
    style: HIDDEN_STYLE,
    "aria-live": "assertive"
  }, getAccessibilityPath(activeItem)), React.createElement("div", {
    role: "tree"
  }, React.createElement("input", {
    style: HIDDEN_STYLE,
    disabled: focusable === false,
    tabIndex: focusable !== false ? tabIndex : null,
    onKeyDown: onInternalKeyDown,
    onFocus: onFocus,
    onBlur: onBlur
  })), React.createElement(VirtualList, Object.assign({}, domProps, {
    disabled: disableVirtual,
    data: mergedData,
    itemKey: itemKey,
    height: height,
    itemHeight: itemHeight,
    onSkipRender: onMotionEnd,
    prefixCls: "".concat(prefixCls, "-list")
  }), function (treeNode) {
    var pos = treeNode.pos,
        _treeNode$data = treeNode.data,
        key = _treeNode$data.key,
        restProps = _objectWithoutProperties(_treeNode$data, ["key"]),
        isStart = treeNode.isStart,
        isEnd = treeNode.isEnd;

    var mergedKey = getKey(key, pos);
    delete restProps.children;
    var treeNodeProps = getTreeNodeProps(mergedKey, treeNodeRequiredProps);
    return React.createElement(MotionTreeNode, Object.assign({}, restProps, treeNodeProps, {
      active: focused && key === activeKey,
      pos: pos,
      data: treeNode.data,
      isStart: isStart,
      isEnd: isEnd,
      motion: motion,
      motionNodes: key === MOTION_KEY ? transitionRange : null,
      motionType: motionType,
      onMotionEnd: onMotionEnd,
      treeNodeRequiredProps: treeNodeRequiredProps,
      onMouseMove: function onMouseMove() {
        setActiveKey(null);
      }
    }));
  }));
};

export default NodeList;